//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include <windows.h>
#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "ImagePanel"
#pragma resource "*.dfm"
//---------------------------------------------------------------------------
TForm1 *Form1;
const int WM_ABNOTIFY=WM_USER+100;
//---------------------------------------------------------------------------
__fastcall TForm1::~TForm1()
{
    DragAcceptFiles(Handle,false);
    // Unreregister AppBar
    SHAppBarMessage(ABM_REMOVE, &abd);
}
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
    Edit1->ComponentIndex=2;
    SpeedButton2->ComponentIndex=3;
    ButtonCount=0;
    ButtonApp=new TStringList;

    abd.cbSize = sizeof(abd);
    abd.hWnd = Handle;
    abd.uCallbackMessage = WM_ABNOTIFY;
    // Register the AppBar
    SHAppBarMessage(ABM_NEW, &abd);
    // Position AppBar on Top
    abd.uEdge=ABE_TOP;
    CalcComponentPos(abd.uEdge);
    SetRect(&abd.rc,0,0,Screen->Width,Screen->Height);
    SHAppBarMessage(ABM_QUERYPOS,&abd);
    // Calculate size
    abd.rc.bottom=abd.rc.top+AppBarHeight;
    SHAppBarMessage(ABM_SETPOS,&abd);
    // Set AppBar to the correct location
    SetWindowPos(abd.hWnd,NULL,abd.rc.left,abd.rc.top,
            abd.rc.right-abd.rc.left,abd.rc.bottom-abd.rc.top,
            SWP_NOZORDER | SWP_NOACTIVATE);
    // Allow dragging file
    DragAcceptFiles(Handle,true);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CreateParams(TCreateParams &Params)
{
    TForm::CreateParams(Params);
    Params.Style= Params.Style &(~(WS_SYSMENU | WS_MAXIMIZEBOX | WS_MINIMIZEBOX));
    // remove the caption
    Params.Style |= WS_POPUP;
    Params.Style ^= WS_DLGFRAME;

    Params.ExStyle= Params.ExStyle &(~WS_EX_APPWINDOW);
    Params.ExStyle= Params.ExStyle | WS_EX_TOOLWINDOW;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::WndProc(TMessage &Message)
{
    switch (Message.Msg)
    {
        case WM_ABNOTIFY:
            switch (Message.WParam)
            {
                case ABN_WINDOWARRANGE:
                    break;
                case ABN_STATECHANGE:
                    break;
                case ABN_FULLSCREENAPP:
                    if (Message.LParam)
                        SetWindowPos(Handle,HWND_BOTTOM,0,0,0,0,
                            SWP_NOMOVE | SWP_NOSIZE | SWP_NOACTIVATE);
                    else SetWindowPos(Handle,HWND_TOPMOST,0,0,0,0,
                            SWP_NOMOVE | SWP_NOSIZE | SWP_NOACTIVATE);
                    break;
                case ABN_POSCHANGED:
                    SHAppBarMessage(ABM_QUERYPOS,&abd);
                    switch (abd.uEdge)
                    {
                        case ABE_LEFT:
                            abd.rc.right=abd.rc.left+AppBarWidth;
                            break;
                        case ABE_TOP:
                            abd.rc.bottom=abd.rc.top+AppBarHeight;
                            break;
                        case ABE_RIGHT:
                            abd.rc.left=abd.rc.right-AppBarWidth;
                            break;
                        case ABE_BOTTOM:
                            abd.rc.top=abd.rc.bottom-AppBarHeight;
                            break;
                    }
                    SHAppBarMessage(ABM_SETPOS,&abd);
                    CalcComponentPos(abd.uEdge);
                    MoveWindow(abd.hWnd,abd.rc.left,abd.rc.top,
                                abd.rc.right-abd.rc.left,
                                abd.rc.bottom-abd.rc.top,TRUE);
                    break;
            }
        case WM_ACTIVATE:
            SHAppBarMessage(ABM_ACTIVATE,&abd);
            Message.Result=true;
            break;
        case WM_MOVING:
            OnMoving(Message);
            Message.Result=true;
            break;
        case WM_EXITSIZEMOVE:
            SHAppBarMessage(ABM_QUERYPOS,&abd);
            SHAppBarMessage(ABM_SETPOS,&abd);
            Message.Result=true;
            break;
        case WM_WINDOWPOSCHANGED:
            SHAppBarMessage(ABM_WINDOWPOSCHANGED,&abd);
            Message.Result=true;
            break;
        case WM_DROPFILES:
            OnDropFiles(Message);
            Message.Result=true;
            break;
        default:
            TForm::WndProc(Message);
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormMouseDown(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y)
{
    ReleaseCapture();
    Perform(WM_SYSCOMMAND, SC_MOVE + HTCAPTION, 0);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::OnMoving(TMessage &Message)
{
    // Get mouse position
    POINT MousePos;
    GetCursorPos(&MousePos);

    // Create 4 Rectangles corresponding to the edges of the screen
    // if the mouse is in one of these Rect, we have to change the uEdge
    // parameter of the APPBARDATA structure, telling the appbar where
    // it has to dock
    RECT Desktop= Rect(0,0,Screen->Width,Screen->Height);
    RECT LeftRect=Rect(Desktop.left,Desktop.top,Desktop.left+AppBarWidth,
                        Desktop.bottom);
    RECT RightRect=Rect(Desktop.right-AppBarWidth,Desktop.top,
                            Desktop.right,Desktop.bottom);
    RECT TopRect=Rect(Desktop.left,Desktop.top,Desktop.right,
                        Desktop.top+AppBarHeight);
    RECT BottomRect=Rect(Desktop.left,Desktop.bottom-AppBarHeight,
                            Desktop.right,Desktop.bottom);

    if(PtInRect(&LeftRect,MousePos))
    {
        abd.rc=LeftRect;
        abd.uEdge=ABE_LEFT;
    }
    else if(PtInRect(&RightRect,MousePos))
    {
        abd.rc=RightRect;
        abd.uEdge=ABE_RIGHT;
    }
    else if(PtInRect(&TopRect,MousePos))
    {
        abd.rc=TopRect;
        abd.uEdge=ABE_TOP;
    }
    else if(PtInRect(&BottomRect,MousePos))
    {
        abd.rc=BottomRect;
        abd.uEdge=ABE_BOTTOM;
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CalcComponentPos(UINT EdgePos)
{
    ControlTop=0;
    ControlLeft=0;
    AppBarWidth=0;
    AppBarHeight=0;
    // Get the biggest Width and Height
    for (int i=0;i<ComponentCount;i++)
    {
        TControl* Control = dynamic_cast<TControl*>(Components[i]);

        if(Control)
        {
            // Get the greatest width and height
            // This will determine the thickness of the appbar
            if(Control->Height>AppBarHeight)
                AppBarHeight=Control->Height;
            if (Control->Width>AppBarWidth)
                AppBarWidth=Control->Width;
        }
    }
    AppBarWidth+=6;
    AppBarHeight+=6;
    //Calc Top and left properties
    for (int i=0;i<ComponentCount;i++)
    {
        TControl* Control = dynamic_cast<TControl*>(Components[i]);

        if(Control)
        {
            if((EdgePos==ABE_LEFT)||(EdgePos==ABE_RIGHT))
            {
                Control->Left=(AppBarWidth-Control->Width)/2;
                Control->Top=ControlTop+1;
                ControlTop=Control->Height+Control->Top;
            }
            if((EdgePos==ABE_TOP)||(EdgePos==ABE_BOTTOM))
            {
                Control->Top=(AppBarHeight-Control->Height)/2;
                Control->Left=ControlLeft+1;
                ControlLeft=Control->Width+Control->Left;
            }
        }
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::OnDropFiles(TMessage &Message)
{
    char *FileName;
    SHFILEINFO FileInfo;

    UINT NumberOfFiles=DragQueryFile((HDROP)Message.WParam,0xFFFFFFFF,NULL,MAX_PATH);
    if (NumberOfFiles>1)ShowMessage("Select only one file at a time!");
    int PathLength=DragQueryFile((HDROP)Message.WParam,0,NULL,0);
    FileName=new Char[PathLength+1];
    DragQueryFile((HDROP)Message.WParam,0,FileName,PathLength+1);

    //Get the icon associated with the file
    if(SHGetFileInfo(FileName,0,&FileInfo,sizeof(FileInfo),SHGFI_ICON))
    {
        Graphics::TIcon *Icon=new Graphics::TIcon();
        Graphics::TBitmap *Bitmap=new Graphics::TBitmap();
        TImageList *ImageList=new TImageList(NULL);
        ImageList->BkColor=clNone;
        TSpeedButton *SpeedButton=new TSpeedButton(this);
        Icon->Handle=FileInfo.hIcon;
        int Index=ImageList->AddIcon(Icon);
        ImageList->GetBitmap(Index,Bitmap);
        SpeedButton->Parent=this;
        SpeedButton->Glyph->Assign(Bitmap);
        SpeedButton->Flat=false;
        SpeedButton->Transparent=false;
        SpeedButton->Caption="";
        SpeedButton->Width=22;
        SpeedButton->Height=22;
        SpeedButton->Tag=ButtonCount;
        SpeedButton->OnClick=DraggedButtonClick;
        ButtonApp->Add(FileName);
        delete Icon;
        delete Bitmap;
        delete ImageList;
    }
    // needed to avoid that the form gets its original width and
    // height again.
    Perform(WM_ABNOTIFY,ABN_POSCHANGED,0);
    delete FileName;
    ButtonCount++;
    DragFinish((HDROP)Message.WParam);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton2Click(TObject *Sender)
{
    if((int)ShellExecute(Handle,"open",Edit1->Text.c_str(),
        NULL,"c:\\winnt",SW_SHOW)<32)
        ShowMessage("Unable to launch your browser");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::DraggedButtonClick(TObject *Sender)
{
    TSpeedButton* SB = dynamic_cast<TSpeedButton*>(Sender);

        if(SB)
        {
            if((int)ShellExecute(Handle,"open",ButtonApp->Strings[SB->Tag].c_str(),
                NULL,NULL,SW_SHOW)<32)
                ShowMessage("Unable to launch your browser");
        }
}
//---------------------------------------------------------------------------

